# flutter_group_button

A flutter package which contains basics grouped buttons like radio buttons and checkboxes

## VERSION
    [2.0.0]

## Table of content
   * [getting start](#getting-start)
   * [Fast Overview](#fast-overview)

[comment]: <> (   * [General info]&#40;#general-info&#41;)

## Getting start
To use this package, add `flutter_group_button^[version]` as a [dependency in your pubspec.yaml file](https://flutter.io/platform-plugins/)

```yaml
dependencies:
  flutter_group_button: ^1.0.1
```

## Fast Overview
    Make sure that dependencie is add to your pubsec.yaml file.
   * [RadioGroup Overview](#radiogroup-overview)
   * [CheckboxGroup Overview](#checkboxgroup-overview)
    
## RadioGroup Overview
```dart
    RadioGroup(
                  children: [
                    Text("Choice 1"),
                    Text("Choice 2"),
                    Text("Choice 3")
                  ],
                    /// no default selected item
                  defaultSelectedItem: -1,
                  onSelectionChanged: (selection) {
                    /// print the index of the selected item
                    print(selection);
                  })
```

[<img src="https://github.com/stMerlHin/repo_im/blob/main/radio_demo.png?raw=true" width="250"/>](https://github.com/stMerlHin/repo_im/blob/main/radio_demo.png?raw=true)
## CheckBoxGroup Overview
    
```dart
    CheckboxGroup(
                  child: {
                    Text("Choice 1"): false,
                    Text("Choice 2"): true,
                    Text("Choice 3"): false
                  },
                  ///  
                  onNewChecked: (l) {
                    /// print a list of the checked item name
                    print(l);
                  })
```

[comment]: <> ([<img src="https://github.com/stMerlHin/repo_im/blob/main/checkbox_demo.png?raw=true" width="250"/>]&#40;https://github.com/stMerlHin/repo_im/blob/main/checkbox_demo.png?raw=true&#41;)

[comment]: <> (## General info)

[comment]: <> (   * [RadioGroup]&#40;#radiogroup&#41;)

[comment]: <> (   * [CheckboxGroup]&#40;#checkboxgroup&#41;)
   
[comment]: <> (#### Illustration)

[comment]: <> (For help getting started with Flutter, view our )

[comment]: <> ([online documentation]&#40;https://flutter.dev/docs&#41;, which offers tutorials, )

[comment]: <> (samples, guidance on mobile development, and a full API reference.)

    

[comment]: <> (## RadioGroup)

[comment]: <> (   The RadioGroup has many arguments for more flexibility which are optional. You can implements theme)

[comment]: <> (   for your needs. Important to know that both the radio button and the radio's label are clickable)

[comment]: <> (* [RadioGroup parameters list]&#40;#radiogroup-parameters-list&#41;)

[comment]: <> (* [RadioGroup parameters details]&#40;#radiogroup-parameters-details&#41;)

[comment]: <> (* [Short illustration of essentials]&#40;#short-illustration&#41;)

[comment]: <> (## RadioGroup parameters list)

[comment]: <> (     groupItemsAlignment,)

[comment]: <> (     onSelectionChanged,)

[comment]: <> (     defaultSelectedItem = 0,)

[comment]: <> (     children,)

[comment]: <> (     textBeforeRadio = true,)

[comment]: <> (     padding = const EdgeInsets.all&#40;0&#41;,)

[comment]: <> (     margin = const EdgeInsets.all&#40;0&#41;,)

[comment]: <> (     activeColor,)

[comment]: <> (     focusColor,)

[comment]: <> (     hoverColor,)

[comment]: <> (     textBelowRadio = true,)

[comment]: <> (     priority = RadioPriority.textBeforeRadio,)

[comment]: <> (     mainAxisAlignment = MainAxisAlignment.start,)

[comment]: <> (     internMainAxisAlignment = MainAxisAlignment.start,)
     
[comment]: <> (## RadioGroup parameters details)

[comment]: <> (#### &#40;@Required&#41; means that the argument is required by the Widget to work properly)

[comment]: <> (    Important to know there is only 3 required parameters for RadioGroup to work)

[comment]: <> (    they are:)

[comment]: <> (        groupItemsAlignment,)

[comment]: <> (        children,)

[comment]: <> (        onSelectionChanged,)

[comment]: <> (#### &#40;@Optional&#41; means that the argument is not required by the RadioGroup to work)

[comment]: <> ( &#40;@Required&#41;)

[comment]: <> (  ### groupItemsAlignment)

[comment]: <> (   The alignment of the RadioGroup Items. It can be GroupItemsAlignment.row for row alignment)

[comment]: <> (    or GroupItemsAlignment.column for column alignment. Note that according to its value and )

[comment]: <> (    the parent of the RadioGroup, you will have to play with both )

[comment]: <> (   [mainAxisAlignment]&#40;#mainaxisalignment&#41; and )

[comment]: <> (   [internalMainAxisAlignment]&#40;#internmainaxisalignment&#41; to make the RadioGroup be at the right place)
   
[comment]: <> ( &#40;@Required&#41;)

[comment]: <> (  ### children)

[comment]: <> (   The item or the list of the items label of the RadioGroup. You can pass any widget or list of widget )

[comment]: <> (    you want but It's good to pass a Text widget or a list of Text widget like shown   )

[comment]: <> (  [here]&#40;#short-illustration&#41;.)

[comment]: <> (    Note that you can add a Style to the Text or use any widget you want.)
    
[comment]: <> ( &#40;@Required&#41;)

[comment]: <> (  ### onSelectionChanged)

[comment]: <> (   Callback called when the selected item changed)

[comment]: <> (    it returns the index of the selected radio button. Note)

[comment]: <> (    that the index start at 0.)
    
[comment]: <> ( &#40;@Optional&#41;)

[comment]: <> (  ### defaultSelectedItem)

[comment]: <> (   &#40;int&#41;: Is the default item to select for the RadioGroup. By default the first item is selected. )

[comment]: <> (    Note that the index begin at 0. If you don't want any item to be selected, just give a)

[comment]: <> (    negative value to it.)
  
[comment]: <> (  &#40;@Optional&#41;)

[comment]: <> (  ### padding)

[comment]: <> (   &#40;EdgeInsetsGeometry&#41;: Empty space to inscribe inside the RadioGroup.)

[comment]: <> ( &#40;@Optional&#41;)

[comment]: <> (  ### textBeforeRadio)

[comment]: <> (   &#40;bool&#41; which tells if the items label must come before or after the radio button.)

[comment]: <> (    By default it's set to true. if you want the opposite, just set it to false)

[comment]: <> ( &#40;@Optional&#41;)

[comment]: <> (  ### textBelowRadio)

[comment]: <> (   &#40;bool&#41;: which tells if the item's label must be below or above the Radio. By default, )

[comment]: <> (    it's set to true. If you want the opposite, just set it to false. One thing to take in consideration,)

[comment]: <> (    the item's label can not be before and below the radio at the same time. it can only be )

[comment]: <> (    &#40;before of after the radio button depending on the textBeforeRadio's value&#41; or )

[comment]: <> (    &#40;below or above the radio button depending on the textBelowRadio's value&#41;, so there is a)

[comment]: <> (   [priority]&#40;#priority&#41; to respect.)

[comment]: <> ( &#40;@Optional&#41;)

[comment]: <> (  ### priority)

[comment]: <> (   &#40;RadioPriority&#41; which tells if the [textBeforeRadio] is important or not than [textBelowRadio].)

[comment]: <> (    it can take two values &#40;RadioPriority.textBeforeRadio or RadioPriority.textBelowRadio&#41;.)

[comment]: <> (    By default, textBeforeRadio is important than textBelowRadio)

[comment]: <> ( &#40;@Optional&#41;)

[comment]: <> (  ### margin)

[comment]: <> (   &#40;EdgeInsetsGeometry&#41; Empty space to surround the the RadioGroup items.)


[comment]: <> ( &#40;@Optional&#41;)

[comment]: <> (  ### mainAxisAlignment&#41;)

[comment]: <> (   &#40;MainAxisAlignment&#41; The main axis alignment of the RadioGroup.)

[comment]: <> (    Depending on the container of the RadioGroup parent, you could need it or not.)

[comment]: <> ( &#40;@Optional&#41;)

[comment]: <> (  ### internMainAxisAlignment)

[comment]: <> (   &#40;MainAxisAlignment&#41;: the internal axis alignment of the RadioGroup.)

[comment]: <> (    You can control the main axis alignment of the radio button and its label.)

[comment]: <> (    Depending on the RadioGroup parent, you can have to play with both mainAxisAlignment )

[comment]: <> (    and this internalRadioAxisAlignment )

[comment]: <> ( &#40;@Optional&#41;)

[comment]: <> (  ### focusColor)

[comment]: <> (   &#40;Color&#41;: The color for the radio's [Material] when it has the input focus.)
    
[comment]: <> ( &#40;@Optional&#41;)

[comment]: <> (  ### hoverColor;)

[comment]: <> (   &#40;Color&#41;: The color for the radio's [Material] when a pointer is hovering over it.)

[comment]: <> (&#40;@Optional&#41;)

[comment]: <> (  ### activeColor)

[comment]: <> (   &#40;Color&#41;: The color to use when this radio button is selected.)

[comment]: <> (    Defaults to [ThemeData.toggleableActiveColor].)


[comment]: <> (## Short illustration   )

[comment]: <> (  ```dart)

[comment]: <> (  import 'package:flutter_group_button/flutter_group_button';  )
   
 
[comment]: <> (  RadioGroup&#40;)

[comment]: <> (              children: [)

[comment]: <> (                Text&#40;"Choice 1"&#41;,)

[comment]: <> (                Text&#40;"Choice 2"&#41;,)

[comment]: <> (                /// fell free to add a textStyle or change the Text to Cupertino)

[comment]: <> (                /// Text widget)

[comment]: <> (                Text&#40;"Choice 3"&#41;)

[comment]: <> (              ],)

[comment]: <> (              //to indicate that there is no default selected item)

[comment]: <> (              defaultSelectedItem: -1,)

[comment]: <> (              onSelectionChanged: &#40;selection&#41; {)

[comment]: <> (                print&#40;selection&#41;;)

[comment]: <> (              }&#41;)

[comment]: <> (  ```)

[comment]: <> (This is the result of the code above )

[comment]: <> ([<img src="https://github.com/stMerlHin/repo_im/blob/main/radio_demo.png?raw=true" width="250"/>]&#40;https://github.com/stMerlHin/repo_im/blob/main/radio_demo.png?raw=true&#41;)
    
[comment]: <> (## CheckboxGroup)

[comment]: <> (   The CheckboxGroup has many arguments for more flexibility which are optional. You can implements theme)

[comment]: <> (   for your needs. Important to know that both the checkbox button and the checkbox's label are clickable)

[comment]: <> (* [List of parameters]&#40;#checkboxgroup-parameters-list&#41;)

[comment]: <> (* [CheckboxGroup parameters details]&#40;#checkbox-parameters-details&#41;)

[comment]: <> (* [Short illustration of essentials]&#40;#checkbox-short-illustration&#41;)

[comment]: <> (## CheckBoxGroup parameters list)

[comment]: <> (    child,)

[comment]: <> (    onNewChecked,)

[comment]: <> (    activeColor,)

[comment]: <> (    focusColor,)

[comment]: <> (    hoverColor,)

[comment]: <> (    checkColor,)

[comment]: <> (    priority = CheckboxPriority.textBeforeCheckbox,)

[comment]: <> (    groupItemsAlignment,)

[comment]: <> (    padding = const EdgeInsets.all&#40;0&#41;,)

[comment]: <> (    margin = const EdgeInsets.all&#40;0&#41;,)

[comment]: <> (    textBeforeCheckbox = true,)

[comment]: <> (    textBelowCheckBox = true,)

[comment]: <> (    mainAxisAlignment = MainAxisAlignment.start,)

[comment]: <> (    internMainAxisAlignment = MainAxisAlignment.start,)



[comment]: <> (## Checkbox parameters details)

[comment]: <> (#### &#40;@Required&#41; means that the argument is required by the Widget to work properly)

[comment]: <> (    Important to know, there is only 3 required parameters for CheckboxGroup to work.)

[comment]: <> (    They are : )

[comment]: <> (        groupItemsAlignment,)

[comment]: <> (        child,)

[comment]: <> (        onNewChecked,)

[comment]: <> (#### &#40;@Optional&#41; means that the argument is not required by the Widget to work)
 
[comment]: <> (   ### groupItemsAlignment &#40;@Required&#41;;)

[comment]: <> (   &#40;GroupItemsAlignment&#41;: The alignment of the CheckboxGroup Items. It can be GroupItemsAlignment.row for row alignment)

[comment]: <> (     or GroupItemsAlignment.column for column alignment. Note that according to its value and )

[comment]: <> (     the parent of the RadioGroup, you will have to play with both)

[comment]: <> (   [mainAxisAlignment]&#40;#mainaxisalignment-optional&#41; and [internalRadioAxisAlignment]&#40;#internmainaxisalignment-optional&#41;)

[comment]: <> (     to make the RadioGroup be right place)
    
 
[comment]: <> (   ### child &#40;@Required&#41;)

[comment]: <> (   &#40;Map<Text, bool&#41;&#41;: The items of the CheckboxGroup.    )

[comment]: <> (   [here]&#40;#short-illustration&#41; is short illustration. Note that you can add a Style to the Text.)
     
     
[comment]: <> (   ### onNewChecked &#40;@Required&#41;)

[comment]: <> (   A callback to notify that a new check box is checked)

[comment]: <> (     Return a list of checked items. Note That only the item's label &#40;String&#41; is returned)
   
[comment]: <> (   ### padding &#40;@Optional&#41;;)

[comment]: <> (   &#40;EdgeInsetsGeometry&#41;: Empty space to inscribe inside the CheckboxGroup.)
 
[comment]: <> (   ### textBeforeCheckbox &#40;@Optional&#41;)

[comment]: <> (   &#40;bool&#41;: tells if the items label must come before or after the checkbox.)

[comment]: <> (     By default it's set to true. if you want the opposite, just set it to false)
 
[comment]: <> (   ### textBelowCheckbox &#40;@Optional&#41;;)

[comment]: <> (   &#40;bool&#41;: tells if the item's label must be below or above the checkbox. By default, )

[comment]: <> (     it's set to true. If you want the opposite, just set it to false. One thing to take in consideration,)

[comment]: <> (     the item's label can not be before and below the checkbox at the same time. it can only be )

[comment]: <> (     &#40;before of after the checkbox depending on the textBeforeCheckbox's value&#41; or )

[comment]: <> (     &#40;below or above the checkbox depending on the textBelowCheckbox's value&#41;, so there is a)

[comment]: <> (   [priority]&#40;#priority-optional&#41; to respect.)
 
[comment]: <> (   ### priority &#40;@Optional&#41;)

[comment]: <> (   &#40;CheckboxPriority&#41;: tells if the [textBeforeCheckbox] is important or not than [textBelowCheckbox].)

[comment]: <> (     it can take two values &#40;CheckboxPriority.textBeforeCheckbox or CheckboxPriority.textBelowCkeckbox&#41;.)

[comment]: <> (     By default, textBeforeCheckbox is important than textBelowCheckbox)
 
[comment]: <> (   ### margin &#40;@Optional&#41;)

[comment]: <> (   &#40;EdgeInsetsGeometry&#41;: Empty space to surround the the RadioGroup items.)
 
 
[comment]: <> (   ### mainAxisAlignment &#40;@Optional&#41;)

[comment]: <> (   &#40;MainAxisAlignment&#41;: The main axis alignment of the CheckboxGroup.)

[comment]: <> (     Depending on the container of the CheckboxGroup parent, you could need it or not.)
 
[comment]: <> (   ### internMainAxisAlignment &#40;@Optional&#41;)

[comment]: <> (   &#40;MainAxisAlignment&#41;: the internal axis alignment of the CheckboxGroup.)

[comment]: <> (     You can control the main axis alignment of the checkbox and its label.)

[comment]: <> (     Depending on the CheckboxGroup parent, you can have to play with both )

[comment]: <> (   [mainAxisAlignment]&#40;#mainaxisalignment-optional&#41; and this internalRadioAxisAlignment )
 
[comment]: <> (   ### focusColor &#40;@Optional&#41;)

[comment]: <> (   &#40;Color&#41;: The color for the checkbox's [Material] when it has the input focus.)
     
[comment]: <> (   ### hoverColor &#40;@Optional&#41;)

[comment]: <> (   &#40;Color&#41;: The color for the checkbox's [Material] when a pointer is hovering over it.)
 
[comment]: <> (   ### activeColor &#40;@Optional&#41;)

[comment]: <> (   &#40;Color&#41;: The color to use when the checkbox is checked.)

[comment]: <> (     Defaults to [ThemeData.toggleableActiveColor].)
     
  
[comment]: <> (  ###  checkColor &#40;@Optional&#41;)

[comment]: <> (   Color&#41; The color to use for the check icon when this checkbox is checked.)

[comment]: <> (    Defaults to Color&#40;0xFFFFFFFF&#41;)


[comment]: <> (## Checkbox short illustration )

[comment]: <> (```dart)

[comment]: <> ( Center&#40;)

[comment]: <> (          child: CheckboxGroup&#40;)

[comment]: <> (              child: {)

[comment]: <> (                Text&#40;"Choice 1"&#41;: false,)

[comment]: <> (                Text&#40;"Choice 2"&#41;: true,)

[comment]: <> (                Text&#40;"Choice 3"&#41;: false)

[comment]: <> (              },)

[comment]: <> (              groupItemsAlignment: GroupItemsAlignment.column,)

[comment]: <> (              mainAxisAlignment: MainAxisAlignment.center,)

[comment]: <> (              internMainAxisAlignment: MainAxisAlignment.center,)

[comment]: <> (              priority: CheckboxPriority.textBeforeCheckbox,)

[comment]: <> (              onNewChecked: &#40;l&#41; {)

[comment]: <> (                print&#40;l&#41;;)

[comment]: <> (              }&#41;)

[comment]: <> (      &#41;,)

[comment]: <> (```)

[comment]: <> (This is the result of the code above)

[comment]: <> ([<img src="https://github.com/stMerlHin/repo_im/blob/main/checkbox_demo.png?raw=true" width="250"/>]&#40;https://github.com/stMerlHin/repo_im/blob/main/checkbox_demo.png?raw=true&#41;)
